﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Azure.Cosmos;
using Microsoft.Extensions.Logging;
using TEAMModelOS.SDK.Module.AzureCosmosDB.Interfaces;

namespace CosmosDBTest.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class WeatherForecastController : ControllerBase
    {
        private static readonly string[] Summaries = new[]
        {
            "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
        };

        private readonly ILogger<WeatherForecastController> _logger;
        private readonly IAzureCosmosDBRepository azureCosmosDBRepository;
        public WeatherForecastController(ILogger<WeatherForecastController> logger, IAzureCosmosDBRepository _azureCosmosDBRepository)
        {
            _logger = logger;
            azureCosmosDBRepository = _azureCosmosDBRepository;
        }

        [HttpGet]
        public IEnumerable<WeatherForecast> Get()
        {
            var rng = new Random();
            return Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = rng.Next(-20, 55),
                Summary = Summaries[rng.Next(Summaries.Length)]
            })
            .ToArray();
        }
        [HttpGet("GetData")]
        public async Task<IEnumerable<Volume>> GetData()
        {

          return await  azureCosmosDBRepository.FindSQL<Volume>("select * from c where c.id= '1'" ,true);
        }
    }
}
