﻿using System;
using System.Collections.Generic;
using System.Text;

namespace EventDemo
{
    /// <summary>
    /// 定义事件接收者
    /// </summary>
    public class Fax
    {
        public Fax(MailManager mm)
        {
            // 构造委托实例，向事件登记回调方法
            mm.NewMail += FaxMsg;
        }
        /// <summary>
        /// 回调方法
        /// </summary>
        /// <param name="sender">表示MailManager对象，便于将信息传递给他</param>
        /// <param name="e">表示MailManager对象想传给我们的附加信息</param>
        private void FaxMsg(object sender, NewMailEventArgs e)
        {
            Console.WriteLine("msg:{0},{1},{2}", e.From, e.To, e.Content);
        }
        /// <summary>
        /// 注销对事件的登记
        /// </summary>
        /// <param name="mm"></param>
        public void Unregister(MailManager mm)
        {
            mm.NewMail -= FaxMsg;
        }
    }
}
