﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.Json;
using System.Threading.Tasks;
using JsonRPC4.Router;
using JsonRPC4.Router.Abstractions;
using JsonRPCTest.Controllers;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;

namespace JsonRPC4.Controllers
{

    [RpcRoute]
    public class WeatherForecastController : RpcController
    {
        private static readonly string[] Summaries = new[]
        {
            "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
        };

        private readonly ILogger<WeatherForecastController> _logger;

        public WeatherForecastController(ILogger<WeatherForecastController> logger)
        {
            _logger = logger;
        }


        //public Task<IRpcMethodResult> Get(Item item, JsonElement bbb)
        //{
        //    var rng = new Random();
        //    var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
        //    {
        //        Date = DateTime.Now.AddDays(index),
        //        TemperatureC = rng.Next(-20, 55),
        //        Summary = Summaries[rng.Next(Summaries.Length)]
        //    })
        //    .ToArray();
        //    return Task.Run<IRpcMethodResult>(() => Ok(aps));
        //}
    
        public Task<IRpcMethodResult> Get(string aaa, string ccc)
        {
            var rng = new Random();
            var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = rng.Next(-20, 55),
                Summary = Summaries[rng.Next(Summaries.Length)]
            })
            .ToArray();
            return Task.Run<IRpcMethodResult>(() => Ok(aps));
        }
    }
}
