﻿using JsonRPC4.Router.Utilities;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace JsonRPC4.Router.Abstractions
{
	public static class RpcRequestHandlerExtensions
	{
		public static async Task<string> HandleRequestAsync(this IRpcRequestHandler handler, RpcPath requestPath, string requestJson, IRouteContext routeContext)
		{
			using (MemoryStream requestStream = StreamUtil.GetStreamFromUtf8String(requestJson))
			{
				using (MemoryStream responseStream = new MemoryStream())
				{
					if (!(await handler.HandleRequestAsync(requestPath, requestStream, routeContext, responseStream)))
					{
						return null;
					}
					responseStream.Position = 0L;
					return await new StreamReader(responseStream).ReadToEndAsync();
				}
			}
		}
	}
}
