﻿using JsonRPC4.Common;
using JsonRPC4.Router.Abstractions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace JsonRPC4.Router.Defaults
{
	public class RpcMethodErrorResult : IRpcMethodResult
	{
		public string Message { get; }

		// Token: 0x17000051 RID: 81
		// (get) Token: 0x060000F5 RID: 245 RVA: 0x00004770 File Offset: 0x00002970
		public int ErrorCode { get; }

		// Token: 0x17000052 RID: 82
		// (get) Token: 0x060000F6 RID: 246 RVA: 0x00004778 File Offset: 0x00002978
		public object Data { get; }

		// Token: 0x060000F7 RID: 247 RVA: 0x00004780 File Offset: 0x00002980
		public RpcMethodErrorResult(int errorCode, string message = null, object data = null)
		{
			this.ErrorCode = errorCode;
			this.Message = message;
			this.Data = data;
		}

		// Token: 0x060000F8 RID: 248 RVA: 0x000047A0 File Offset: 0x000029A0
		public RpcResponse ToRpcResponse(RpcId id)
		{
			RpcError error = new RpcError(this.ErrorCode, this.Message, this.Data);
			return new RpcResponse(id, error);
		}
	}
}
