﻿using System;
using System.Buffers;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.Json;
using System.Threading.Tasks;
using EdjCase.JsonRpc.Router;
using EdjCase.JsonRpc.Router.Abstractions;
using JsonRPCTest.Controllers;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json.Linq;
using TEAMModelOS.SDK.Extension.DataResult.JsonRpcRequest;
using WebTest.JsonPath;
using WebTest.JsonRPC;
using static System.Text.Json.JsonElement;

namespace WebTest.Controllers
{
    
    [RpcRoute]
    public class WeatherForecastController : RpcController
    {
        private static readonly string[] Summaries = new[]
        {
            "Freezing", "Bracing", "Chilly", "Cool", "Mild", "Warm", "Balmy", "Hot", "Sweltering", "Scorching"
        };

        private readonly ILogger<WeatherForecastController> _logger;

        public WeatherForecastController(ILogger<WeatherForecastController> logger)
        {
            _logger = logger;
        }


        //public Task<IRpcMethodResult> Get(Item item, JObject bbb)
        //{
        //    var rng = new Random();
        //    var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
        //    {
        //        Date = DateTime.Now.AddDays(index),
        //        TemperatureC = rng.Next(-20, 55),
        //        Summary = Summaries[rng.Next(Summaries.Length)]
        //    })
        //    .ToArray();
        //    return Task.Run<IRpcMethodResult>(() => Ok(aps));
        //}
        //public Task<IRpcMethodResult> Get(Item item)
        //{
        //    var rng = new Random();
        //    var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
        //    {
        //        Date = DateTime.Now.AddDays(index),
        //        TemperatureC = rng.Next(-20, 55),
        //        Summary = Summaries[rng.Next(Summaries.Length)]
        //    })
        //    .ToArray();
        //    return Task.Run<IRpcMethodResult>(() => Ok(aps));
        //}

        public Task<IRpcMethodResult> Get(Item iterm) {
            var rng = new Random();
            var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = rng.Next(-20, 55),
                Summary = Summaries[rng.Next(Summaries.Length)]
            })
            .ToArray();
            return Task.Run<IRpcMethodResult>(() => Ok(aps));
        }
        public Task<IRpcMethodResult> Get(Item  iterm,  JsonElement element)
        {
            var rng = new Random();
            var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = rng.Next(-20, 55),
                Summary = Summaries[rng.Next(Summaries.Length)]
            })
            .ToArray();
            return Task.Run<IRpcMethodResult>(() => Ok(aps));
        }
        public Task<IRpcMethodResult> Get(Item iterm, JObject element,int a)
        {
            var rng = new Random();
            var aps = Enumerable.Range(1, 5).Select(index => new WeatherForecast
            {
                Date = DateTime.Now.AddDays(index),
                TemperatureC = rng.Next(-20, 55),
                Summary = Summaries[rng.Next(Summaries.Length)]
            })
            .ToArray();
            return Task.Run<IRpcMethodResult>(() => Ok(aps));
        }
    }
}
